<?php

/**
 * @file
 * Views hook implementations for the Search API Views module.
 */

/**
 * Implements hook_views_data_alter().
 */
function search_api_extended_processors_views_data_alter(&$data) {
  // Overriding standard index ViewsQuery class
  foreach (search_api_index_load_multiple(FALSE) as $index) {
    $key = 'search_api_index_' . $index->machine_name;
    $base = &$data[$key]['table']['base'];
    $base['query class'] = 'search_api_extended_processor_query';
  }

}

/**
 * Implements hook_views_plugins().
 */
function search_api_extended_processors_views_plugins() {
  $ret = search_api_views_views_plugins();

  // Removing previous query
  unset($ret['query']['search_api_views_query']);

  // Removing previous facets (?)
  unset($ret['display']['search_api_views_facets_block']);

  $ret['query'] = array(
    'search_api_extended_processor_query' => array(
      'title' => t('Search API Query (With extended Processor)'),
      'help' => t('Query will be generated and run using the Search API with extended processors.'),
      'handler' => 'SearchApiExtendedProcessorViewsQuery',
    ),
  );

  return $ret;
}
